export class LinkNode {
    value;
    next;
    constructor(value) {
        this.value = value;
        this.next = null;
    }
}
export class LinkedQueue {
    head;
    tail;
    _size;
    get size() {
        return this._size;
    }
    constructor() {
        this.head = null;
        this.tail = null;
        this._size = 0;
    }
    _push(value) {
        const newNode = new LinkNode(value);
        if (!this.head) {
            this.head = newNode;
            this.tail = newNode;
        }
        else {
            this.tail.next = newNode;
            this.tail = newNode;
        }
        this._size++;
    }
    push(...values) {
        for (const value of values) {
            this._push(value);
        }
    }
    shift() {
        if (!this.head)
            return null;
        const value = this.head.value;
        this.head = this.head.next;
        this._size--;
        return value;
    }
}
//# sourceMappingURL=LinkedQueue.js.map